
/* Chrysalide - Outil d'analyse de fichiers binaires
 * bits-int.h - prototypes internes pour la conservation d'un champ de bits entre attribut et binaire
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _PLUGINS_KAITAI_RECORDS_BITS_INT_H
#define _PLUGINS_KAITAI_RECORDS_BITS_INT_H


#include "bits.h"


#include "../record-int.h"



/* Correspondance de bits établie entre un attribut et du binaire (instance) */
struct _GRecordBitField
{
    GMatchRecord parent;                    /* A laisser en premier        */

    ext_vmpa_t epos;                        /* Point de départ             */
    uint8_t size;                           /* Quantité de bits concernés  */
    SourceEndian endian;                    /* Boutisme des données imposé */

};

/* Correspondance de bits établie entre un attribut et du binaire (classe) */
struct _GRecordBitFieldClass
{
    GMatchRecordClass parent;               /* A laisser en premier        */

};


/* Met en place une correspondance entre attribut et binaire. */
bool g_record_bit_field_create(GRecordBitField *, GKaitaiAttribute *, GBinContent *, const ext_vmpa_t *, uint8_t, SourceEndian);



#endif  /* _PLUGINS_KAITAI_RECORDS_BITS_INT_H */
